
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>从头认识java-4.9 枚举类型 / 憋错料</title>

    <meta name="description" content="从头认识java-4.9 枚举类型 这一章节我们来简单聊一下枚举类型. 1.枚举类型是一种数据类型 package com.ray.ch04; public class Test { public static void main(String[] args) { MyType myType = MyType.ONE; System.out.println(myType instanceof Object); } } enum MyType { ONE, TWO, THREE } 输出: true 2.枚举类型已经重写了tosti">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">从头认识java-4.9 枚举类型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>这一章节我们来简单聊一下枚举类型。</p>
<p>1.枚举类型是一种数据类型</p>
<pre>package com.ray.ch04;

public class Test {

	public static void main(String[] args) {
		MyType myType = MyType.ONE;
		System.out.println(myType instanceof Object);
	}
}

enum MyType {
	ONE, TWO, THREE
}</pre>
<p>输出：</p>
<p>true</p>
<p>2.枚举类型已经重写了tosting方法，可以直接输出。</p>
<pre>package com.ray.ch04;

public class Test {

	public static void main(String[] args) {
		System.out.println(MyType.ONE);
	}
}

enum MyType {
	ONE, TWO, THREE
}</pre>
<p>输出：</p>
<p>ONE</p>
<p>3.有自己独特的方法</p>
<pre>package com.ray.ch04;

public class Test {

	public static void main(String[] args) {
		for (MyType myType : MyType.values()) {
			System.out.println(myType.toString()+&quot;:&quot; + myType.ordinal() + &quot;&quot;);
		}
	}
}

enum MyType {
	ONE, TWO, THREE
}</pre>
<p>输出：</p>
<p>ONE:0<br />TWO:1<br />THREE:2</p>
<p>4.跟switch联合使用</p>
<pre>package com.ray.ch04;

public class Test {

	private static int getNum(MyType myType) {
		switch (myType) {
		case ONE:
			return 1;
		case TWO:
			return 2;
		case THREE:
			return 3;
		default:
			return 1;
		}
	}

	public static void main(String[] args) {
		System.out.println(Test.getNum(MyType.ONE));
	}
}

enum MyType {
	ONE, TWO, THREE
}</pre>
<p>输出：</p>
<p>1</p>
<p>总结：这一章节主要讲述了枚举类型的概念和应用。</p>
<p>这一章节就到这里，谢谢。</p>
<p>-----------------------------------</p>
<p><a href="http://blog.csdn.net/raylee2007/article/details/49100439" rel="external nofollow noreferrer">目录</a></p>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 15:37:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>从头认识java-4.9 枚举类型的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lD1PX0.html" rel="bookmark">【转】Java基础笔记 &ndash; 枚举类型的使用介绍和静态导入--不错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文网址:http://www.itzhai.com/java-based-notes-introduction-and-use-of-an-enumeration-type-static-import.html#1.2.values方法的使用: Java基础笔记 – 枚举类型的使用介绍和静态导入 本文由arthinking发表于4年前 | Java基础 | 暂无评论 |  被围观 8,332 views+ 1.枚举(Enum):1.1.枚举类型中的两个静态方法:1.2.values方法的使用:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZYPkd0.html" rel="bookmark">Java中的枚举类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				枚举类型可以限定只能取特定值中的某一个. 这个是在编译器就可以限定的. 记住一个原则,错误越早发现越好,尽量在编译器发现. 枚举使用enum(小写)关键字 是java.lang.Enum类型,since jdk1.5 语法 public enum MyColor { red, green, blue };//限定了,用户如果要使用MyColor类型的话,就只能呢使用red,green或者blue三者之一. { MyColor m = MyColor.red; switch(m) {//枚举类型的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RGWp73.html" rel="bookmark">浅谈java中的枚举类型（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用法一:常量 在JDK1.5 之前,我们定义常量都是: public static fianl.... .现在好了,有了枚举,可以把相关的常量分组到一个枚举类型里,而且枚举提供了比常量更多的方法. public enum Color { RED, GREEN, BLANK, YELLOW } 用法二:switch JDK1.6之前的switch语句只支持int,char,enum类型,使用枚举,能让我们的代码可读性更强. enum Signal { GREEN, YELLOW, RED } pu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49E7db4.html" rel="bookmark">深入Java 1&period;5枚举类型的内部实现原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java是一种面向对象的高级编程语言.它的出众之处就在于它的简洁.一个程序员所要做的就是创建类(Create Class)以及定义接口(Define Interface),如此而已.当然,这种简洁和优美是有代价的,比如失去了Enum这种广泛使用的数据类型就是一个不小的损失.在Java 1.5以前,程序员们不得不通过一些变通的方法来间接的解决这一问题.比如说,被普遍使用的整数枚举替代法和类型安全类替代法(Type safe Enum).在正式讨论Java 1.5的枚举类型之前,让我们先简单回顾一下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xooXBM.html" rel="bookmark">java编程思想-枚举类型思维导图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				后续加深理解,感觉java编程思想内容博大精深,java每个特性都有很全面深入的讲解,实际工作中一般很难会遇到,期望以后会用到 把书中的代码copy到eclipse中,理解会更快一些			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ekO7a4.html" rel="bookmark">java中使用枚举类型，代码如下</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public enum CommonStatus {    NORMAL(1), PAUSE(2), DELETE(3);    private int value;    private CommonStatus(int v) {        this.value = v;    }        public int getValue() {        return value;    }        public static String getName(int v) {    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6lyo53.html" rel="bookmark">java 枚举类型使用总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注:阅读了effective java 讲诉enum的部分,做下笔记,下文中大部分代码来自effective java书中 枚举类型是指由一组固定的常量组成的合法值得类型. 使用枚举的好处:a,因为没有可以访问的构造器,枚举类型是真正的final; b,枚举类型提供类编译时的类型安全.如:函数中声明一个参数类型为枚举类型的Apple时,那么调用方法时传递到参数上的任何非null对象一定是Apple的值之一, 而是用静态常量就无法保证; c,包含同名常量的多个枚举类型可以和平共处,每个类型都有自己			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MENJrZ0.html" rel="bookmark">【转】java枚举类型enum的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文网址:http://blog.csdn.net/wgw335363240/article/details/6359614 java 枚举类型enum 的使用 最近跟同事讨论问题的时候,突然同事提到我们为什么java 中定义的常量值不采用enmu 枚举类型,而采用public final static 类型来定义呢?以前我们都是采用这种方式定义的,很少采用enum 定义,所以也都没有注意过,面对突入起来的问题,还真有点不太清楚为什么有这样的定义.既然不明白就抽时间研究下吧. Java 中的枚举			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGY2jQ3.html" rel="bookmark">Java枚举类型enum使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java的Enum枚举类型终于在j2se1.5出现了.之前觉得它只不过是鸡肋而已,可有可无.毕竟这么多年来,没有它,大家不都过得很好吗?今日看&lt;Thinking in Java&gt;4th edition,里面有一句话“有时恰恰因为它,你才能够&quot;优雅而干净&quot;地解决问题.优雅与清晰很重要,正式它们区别了成功的解决方案与失败的解决方案.而失败的解决方案就是因为其他人无法理他.&quot;使用Enum枚举类型,可以将以前笨拙的代码变得优雅简单?但是,我同时也在思考另外一个问题,使用新			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38Kwd10.html" rel="bookmark">java 枚举类型enum 的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java 枚举类型enum 的使用 最近跟同事讨论问题的时候,突然同事提到我们为什么java 中定义的常量值不采用enmu 枚举类型,而采用public final static 类型来定义呢?以前我们都是采用这种方式定义的,很少采用enum 定义,所以也都没有注意过,面对突入起来的问题,还真有点不太清楚为什么有这样的定义.既然不明白就抽时间研究下吧. Java 中的枚举类型采用关键字enum 来定义,从jdk1.5才有的新类型,所有的枚举类型都是继承自Enum 类型.要了解枚举类型,建议大家先			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0e6QD3.html" rel="bookmark" class="title">使用 electron 实现类似新版 QQ 的登录界面效果（阴影、背景动画、窗体3D翻转）</a>
					<div>
						上文&lt;使用 VS2017 和 js 进行桌面程序开发 - electron 之 Hello Word&gt;介绍了如何使用 VS2017 开发 electron 桌面程序,今天来点有看头的,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDamY0.html" rel="bookmark" class="title">windows 2008R2 安装TortoiseSVN  软件</a>
					<div>
						前言,最近想安装一个SVN版控制程序,百度了一下,网上的文章写得都不太合我意,走了不少弯路,特此,自己写一篇,以帮忙有需要的人,写得不好,就多包含了. 下载TortoiseSVN安装包,内含中文语言包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDmOWM.html" rel="bookmark" class="title">简单的鼠标拖动效果</a>
					<div>
						使用js实现简单的鼠标拖动效果,但此部分代码有个小小的BUG,后期改进好我会写进来,但基本的效果已经实现,请大家参考. &lt;!DOCTYPE html&gt; &lt;html lang=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKk5L3.html" rel="bookmark" class="title">C&num; 初识Ref和Out</a>
					<div>
						首先:两者都是按地址传递的,使用后都将改变原来参数的数值. 其次:ref可以把参数的数值传递进函数,但是out是要把参数清空,就是说你无法把一个数值从out传递进去的,out进去后,参数的数值为空,所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x5jzr3.html" rel="bookmark" class="title">&period;pull-left &lbrace; float&colon; left&excl;important&semi;</a>
					<div>
						!important会提升该条规则的优先级,如果有如下2条规则 1 2 .pull-left{color:red !important;} .pull-left{color:green;} 这样pul ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ON58X0.html" rel="bookmark" class="title">解决shiro会话标识未更新问题</a>
					<div>
						要解决会话标识未更新的安全问题,就需要在做登录验证时生成新的session,所以需要先将原来的session失效. 一般的解决方法如下: public void login(HttpServletRe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWG1ZM.html" rel="bookmark" class="title">C&num;常用方法集合</a>
					<div>
						public class Utility:Page { #region 数据转换 /// &lt;summary&gt; /// 返回对象obj的String值,obj为null时返回空值. ///  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoaXBk3.html" rel="bookmark" class="title">Android开发的那些坑和小技巧</a>
					<div>
						1.android:clipToPadding 意思是控件的绘制区域是否在padding里面.默认为true.如果你设置了此属性值为false,就能实现一个在布局上事半功陪的效果.先看一个效果图. 上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZ8NyM.html" rel="bookmark" class="title">MATERIAL DESIGN学习笔记</a>
					<div>
						一.核心思想 ,aterial design的核心思想,就是把物理世界的体验带进屏幕.去掉现实中的杂质和随机性,保留其最原始纯净的形态.空间关系.变化与过渡,配合虚拟世界的灵活特性,还原最贴近真实的体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WmVJ0.html" rel="bookmark" class="title">Python中的高级数据结构&lpar;转&rpar;</a>
					<div>
						add by zhj: Python中的高级数据结构 数据结构 数据结构的概念很好理解,就是用来将数据组织在一起的结构.换句话说,数据结构是用来存储一系列关联数据的东西.在Python中有四种内建的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzeJ73.html" rel="bookmark" class="title">服务订单SO创建</a>
					<div>
						FUNCTION Z_SD_SALESORDER_CREATE. *&quot;------------------------------------------------------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZWqX0.html" rel="bookmark" class="title">明晨HOSTS编辑器mcHostsEdtor与火狐HostAdmin配合使用</a>
					<div>
						在开发过程中,需要经常切换环境开发.测试.Stage和正式环境,甚为麻烦. 后来找到了HOST切换工具mcHostsEdtor工具快速切换host,但浏览器比如有HOST缓存,后来同事推荐FireFo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqg7k3.html" rel="bookmark" class="title">【Head First Servlets and JSP】笔记16：JSP隐式对象（内置对象）</a>
					<div>
						接笔记15. 1.不管是JSP中的&lt;%%&gt;还是&lt;%\=%&gt;最终都将处于servlet的方法体中,那么有没有一种元素可以声明成类的成员呢? ——答案是有,而且非常非常简单,这个元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLJqg4.html" rel="bookmark" class="title">初入spring boot（四 ）web项目</a>
					<div>
						1. 模板引擎 spring boot提供了大量的模板引擎,包括FreeMark.Groovy.Thymeleaf.Velocity等,但spring boot中推荐用Thymeleaf,因为Thym ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNZb73.html" rel="bookmark" class="title">初识消息队列</a>
					<div>
						一对一 点对点模型特性:消息只有在处理成功后才会删除,失败时不会删除,这样下次取时,队列中还会有 发布-订阅模型特性(3.可以理解为过期时间) 发布订阅模型(3非持久订阅:保持长链接---持久订阅:消 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjAmq0.html" rel="bookmark" class="title">利用IPC&dollar;共享入侵windowsXP实战</a>
					<div>
						测试环境:主机(windows XP sp3)与windows XP 虚拟机)   通过IPC$与windowsXP建立连接,在现在的绝大多数的XP操作系统中总是会出现问题.以下如何解决在建立IPC$ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j8XjA4.html" rel="bookmark" class="title">国内外从事CV相关的企业&lbrack;转&rsqb;</a>
					<div>
						提示:本文为笔者原创,转载请注明出处:blog.csdn.net/carson2005 经常碰到朋友问我国内从事计算机视觉(CV)领域的公司的发展情况,产品情况,甚至找工作等问题,这里,我给出自己收集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q1vLG3.html" rel="bookmark" class="title">136-KC705E 增强版 基于FMC接口的Xilinx Kintex-7 FPGA K7 XC7K325T PCIeX8 接口卡</a>
					<div>
						KC705E 增强版 基于FMC接口的Xilinx Kintex-7 FPGA K7 XC7K325T PCIeX8 接口卡 一.板卡概述 本板卡基于Xilinx公司的FPGAXC7K325T-2FF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MorvWw4.html" rel="bookmark" class="title">防火墙 关闭启动</a>
					<div>
						1) 重启后生效 开启: chkconfig iptables on 关闭: chkconfig iptables off 2) 即时生效,重启后失效 开启: service iptables sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyAQKVM.html" rel="bookmark" class="title">Objective-C &commat;class</a>
					<div>
						@class主要是在h(头文件)中使用.主要的作用是告诉编译器:我要在本类中,使用另一个类. 假设要在Aonauly类中使用Action类,使用@class实现过程如下: 首先是定义Action 1, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
